    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ------------
    028     * Outlier.java
    029     * ------------
    030     * (C) Copyright 2003-2005, by David Browning and Contributors.
    031     *
    032     * Original Author:  David Browning (for Australian Institute of Marine
    033     *                   Science);
    034     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    035     *
    036     * $Id: Outlier.java,v 1.4.2.1 2005/10/25 20:53:40 mungady Exp $
    037     *
    038     * Changes
    039     * -------
    040     * 05-Aug-2003 : Version 1, contributed by David Browning (DG);
    041     * 28-Aug-2003 : Minor tidy-up (DG);
    042     *
    043     */
    044
    045    package org.jfree.chart.renderer;
    046
    047    import java.awt.geom.Point2D;
    048
    049    /**
    050     * Represents one outlier in the box and whisker plot.
    051     * <P>
    052     * All the coordinates in this class are in Java2D space.
    053     *
    054     * @author David Browning
    055     */
    056    public class Outlier implements Comparable {
    057
    058        /**
    059         * The xy coordinates of the bounding box containing the outlier ellipse.
    060         */
    061        private Point2D point;
    062
    063        /** The radius of the ellipse */
    064        private double radius;
    065
    066        /**
    067         * Constructs an outlier item consisting of a point and the radius of the
    068         * outlier ellipse
    069         *
    070         * @param xCoord  the x coordinate of the point.
    071         * @param yCoord  the y coordinate of the point.
    072         * @param radius  the radius of the ellipse.
    073         */
    074        public Outlier(double xCoord, double yCoord, double radius) {
    075            this.point = new Point2D.Double(xCoord - radius, yCoord - radius);
    076            this.radius = radius;
    077        }
    078
    079        /**
    080         * Returns the xy coordinates of the bounding box containing the outlier
    081         * ellipse.
    082         *
    083         * @return The location of the outlier ellipse.
    084         */
    085        public Point2D getPoint() {
    086            return this.point;
    087        }
    088
    089        /**
    090         * Sets the xy coordinates of the bounding box containing the outlier
    091         * ellipse.
    092         *
    093         * @param point  the location.
    094         */
    095        public void setPoint(Point2D point) {
    096            this.point = point;
    097        }
    098
    099        /**
    100         * Returns the x coordinate of the bounding box containing the outlier
    101         * ellipse.
    102         *
    103         * @return The x coordinate.
    104         */
    105        public double getX() {
    106            return getPoint().getX();
    107        }
    108
    109        /**
    110         * Returns the y coordinate of the bounding box containing the outlier
    111         * ellipse.
    112         *
    113         * @return The y coordinate.
    114         */
    115        public double getY() {
    116            return getPoint().getY();
    117        }
    118
    119        /**
    120         * Returns the radius of the outlier ellipse.
    121         *
    122         * @return The radius.
    123         */
    124        public double getRadius() {
    125            return this.radius;
    126        }
    127
    128        /**
    129         * Sets the radius of the outlier ellipse.
    130         *
    131         * @param radius  the new radius.
    132         */
    133        public void setRadius(double radius) {
    134            this.radius = radius;
    135        }
    136
    137        /**
    138         * Compares this object with the specified object for order, based on
    139         * the outlier's point.
    140         *
    141         * @param   o the Object to be compared.
    142         * @return A negative integer, zero, or a positive integer as this object
    143         *      is less than, equal to, or greater than the specified object.
    144         *
    145         */
    146        public int compareTo(Object o) {
    147            Outlier outlier = (Outlier) o;
    148            Point2D p1 = getPoint();
    149            Point2D p2 = outlier.getPoint();
    150            if (p1.equals(p2)) {
    151                return 0;
    152            }
    153            else if ((p1.getX() < p2.getX()) || (p1.getY() < p2.getY())) {
    154                return -1;
    155            }
    156            else {
    157                return 1;
    158            }
    159        }
    160
    161        /**
    162         * Returns a true if outlier is overlapped and false if it is not.
    163         * Overlapping is determined by the respective bounding boxes plus
    164         * a small margin.
    165         *
    166         * @param other  the other outlier.
    167         *
    168         * @return A <code>boolean</code> indicating whether or not an overlap has
    169         *         occurred.
    170         */
    171        public boolean overlaps(Outlier other) {
    172            return ((other.getX() >= getX() - (this.radius * 1.1))
    173                    && (other.getX() <= getX() + (this.radius * 1.1))
    174                    && (other.getY() >= getY() - (this.radius * 1.1))
    175                    && (other.getY() <= getY() + (this.radius * 1.1)));
    176        }
    177
    178        /**
    179         * Returns a textual representation of the outlier.
    180         *
    181         * @return A <code>String</code> representing the outlier.
    182         */
    183        public String toString() {
    184            return "{" + getX() + "," + getY() + "}";
    185        }
    186
    187    }